      SUBROUTINE QSFAR(RINT1,RINT2,A,B,F,RO,FI,E,ALFA,BETA,
     1XA,E1,L1,L2)
      DIMENSION BE(5),BI(5),BJ(5),BK(5),BW(7)
      INTEGER L1,L2,IL,U,V,X,BD
      REAL RINT1,RINT2,A,B,F,RO,FI,E,ALFA,BETA,XA,E1,BE,BI,
     1BJ,BK,BW,EPS,TAU,W,P,H,Z1,Z2,E2,E3,J1,J2,RINT3,RINT4,
     1C,D,G,I,J,K,L,M,O,Q,R,S,T,BA,BB,BC,BF,BG,BH,BL,BM,BN,
     1BO,BP,BQ,BR,BS,BT,BU,BV,BX,HM,SYS059,CON
      REAL CONT99,CONE
      LOGICAL MI,NI,Y,Z,NIS
      DATA  SYS059/3.4E38/,CON/2.E-10/
      DATA CONT99/0.999999/,CONE/1.E-15/
      NIS=A.GT.B
      IF(.NOT.(NIS)) GO TO 1
      BA=A
      A=B
      B=BA
    1 V=2
      EPS=E
      HM=CON
      XA=-SYS059
      Y=.TRUE.
      X=1
      C=0.
      D=0.
      G=0.
      I=0.
      IF(BETA-ALFA) 2,3,4
    2 BA=ALFA
      ALFA=BETA
      BETA=BA
      GO TO 4
    3 ALFA=ALFA-HM
      BETA=BETA+HM
    4 IF(B-100.) 7,5,5
    5 IF(A+100.) 6,6,38
    6 Y=.FALSE.
      X=-1
      K=B
      E=E/2.
      B=A
      A=ALFA
      GO TO 38
    7 X=-1
      O=A
      A=B
      B=O
      GO TO 38
    8 NI=A.GT.B
      IF(.NOT.(NI)) GO TO 9
      BA=A
      A=B
      B=BA
    9 W=B-A
      IF(.NOT.(W.EQ.0.)) GO TO 10
      J1=0.
      J2=0.
      E1=0.
      GO TO 37
   10 MI=ALFA.LT.BETA.AND.(A.LE.ALFA.AND.ALFA.LT.B.OR.A.LT.BETA
     1.AND.BETA.LE.B)
      IF(.NOT.(MI)) GO TO 12
      ALFA=(ALFA-A)/W
      BETA=(BETA-A)/W
      TAU=(BETA-ALFA)/2.
      IF(TAU-HM) 11,11,12
   11 TAU=HM
   12 Z2=E/W
      H=1.
      Z1=EPS/W
      P=0.
      E1=0.
      J1=0.
      J2=0.
   13 IF(.NOT.MI) GO TO 14
      IF(.NOT.(P.LT.BETA.AND.(P+H).GT.ALFA.AND.H.GT.TAU))
     1 GO TO 14
      H=TAU
      IF(P.GE.ALFA) GO TO 14
      H=ALFA-P
      IF(H.LT.TAU) H=TAU
   14 BM=H/2.
      BL=W*BM
      BQ=BL*RO
      BO=H*.25
      DO 15 BD=1,5
      BI(BD)=F(A+W*(P+BO*FLOAT(BD-1)))
   15 CONTINUE
   16 IF(FLOAT(L1+L2).LT.1.5.AND.BQ.LE..25) GO TO 17
      BN=ABS(BI(1)+BI(5)-4.*(BI(2)+BI(4))+6.*BI(3))
      GO TO 19
   17 BF=(A+W*(P+BM))*RO+FI
      DO 18 BD=1,5
      BJ(BD)=BI(BD)*SIN(BF)
      BK(BD)=BI(BD)*COS(BF)
   18 CONTINUE
      BF=BJ(1)+BJ(5)-4.*(BJ(2)+BJ(4))+6.*BJ(3)
      BN=BK(1)+BK(5)-4.*(BK(2)+BK(4))+6.*BK(3)
      BN=AMAX1(FLOAT(L1)*ABS(BF),FLOAT(L2)*ABS(BN))
   19 BN=BN*BM*.42
      IF(ABS(BN)-Z1) 25,20,20
   20 H=H/2.
      IF(64.+H-64.) 21,21,24
   21 IF(P) 22,22,23
   22 IF(H/4.) 23,23,24
   23 XA=(P+A)*W
      P=P+2.*H
      H=H*2.
      GO TO 25
   24 BI(5)=BI(3)
      BI(3)=BI(2)
      BM=H*.5
      BQ=W*BM*RO
      BO=H*.25
      BP=P+BO
      BI(2)=F(A+W*BP)
      BI(4)=F(A+W*(BP+BM))
      GO TO 16
   25 E1=E1+ABS(BN)
      BF=(A+W*(P+BM))*RO+FI
      BT=SIN(BF)
      BU=COS(BF)
      BL=W*BM
      BV=RO*BL
      BW(4)=SIN(BV)
      BW(5)=COS(BV)
      IF(BV-0.33) 26,26,27
   26 BX=BV*0.5
      BW(6)=SIN(BX)
      BW(7)=COS(BX)
      BE(1)=.2666667
      BE(2)=.7111111*BW(7)
      BE(3)=.1555556*BW(5)
      BE(4)=.7111111*BW(6)
      BE(5)=.1555556*BW(4)
      GO TO 28
   27 BW(1)=1./BV
      BW(2)=BW(1)*BW(1)
      BW(3)=BW(2)*BW(2)
      BE(1)=4.*BW(2)*(BW(1)*(48.*BW(2)-19.)*BW(4)+3.*(1.-
     116.*BW(2))*BW(5))
      BE(2)=32.*BW(2)*(BW(1)*(5.-12.*BW(2))*BW(4)-(1.-12.*
     1BW(2))*BW(5))/3.
      BE(3)=BW(1)*((3.-46.*BW(2)+96.*BW(3))*BW(4)+2.*BW(1)*
     1(7.-48.*BW(2))*BW(5))/3.
      BE(4)=-16.*BW(2)*((1.-3.*BW(2))*BW(4)+3.*BW(1)*BW(5))/
     13.
      BE(5)=BW(1)*(BW(1)*(11.-24.*BW(2))*BW(4)-3.*(1.-8.*
     1BW(2))*BW(5))/3.
   28 BR=BE(1)*BI(3)+BE(2)*(BI(2)+BI(4))+BE(3)*(BI(1)+BI(5))
      BS=BE(4)*(BI(4)-BI(2))+BE(5)*(BI(5)-BI(1))
      J1=J1+(BT*BR+BU*BS)*BM
      J2=J2+(BU*BR-BT*BS)*BM
      P=P+H
      BH=1.-P
      IF(1.+BH/64.-1.) 29,29,31
   29 BG=(ABS(F(B))+ABS(BI(5)))*H/2.
      IF(BG-Z2) 35,35,30
   30 E1=E1+BG
      GO TO 35
   31 BI(1)=BI(5)
      IF(BN-Z1/32.) 32,33,33
   32 H=2.*H
   33 IF(H-BH) 13,13,34
   34 H=BH
      GO TO 13
   35 J1=J1*W
      J2=J2*W
      E1=E1*W
      IF(.NOT.(NI)) GO TO 36
      BA=B
      B=A
      A=BA
   36 IF(.NOT.(MI)) GO TO 37
      ALFA=ALFA*W+A
      BETA=BETA*W+A
   37 GO TO (42,47),U
   38 IL=1
      J=B
      L=A
      E2=E
      E=1000.
   39 B=L+V*X
      IF((B-J)*X) 41,41,40
   40 B=J
   41 U=1
      GO TO 8
   42 RINT1=J1
      RINT2=J2
      Q=AMAX1(ABS(J1)*FLOAT(L1),ABS(J2)*FLOAT(L2))
      E3=E1
   43 R=Q
   44 Z=.FALSE.
      A=B
      B=L+(B-L)*V
      IF((B-J)*X) 46,46,45
   45 B=J
   46 U=2
      GO TO 8
   47 RINT1=RINT1+J1
      RINT2=RINT2+J2
      Q=AMAX1(ABS(J1)*FLOAT(L1),ABS(J2)*FLOAT(L2))
      E3=E3+E1
      IF(Q.EQ.0..AND.R.EQ.0.) GO TO 51
   48 IF(Q-CONT99*R)     49,44,44
   49 S=Q/R
      S=Q*S/(1.-S)
      IF(S-E2) 50,44,44
   50 IF(.NOT.(Z)) GO TO 58
      E3=E3+S
   51 IL=IL+1
      BB=AMAX1(ABS(RINT1)*FLOAT(L1),ABS(RINT2)*FLOAT(L2))
      BB=E2*(1.+BB)
      IF(E3-BB) 59,59,52
   52 IF(IL-1) 53,54,53
   53 BC=AMAX1((ABS(RINT1-RINT3)/(1.+ABS(RINT3))*FLOAT(L1)),
     1(ABS(RINT2-RINT4)/(1.+ABS(RINT4))*FLOAT(L2)))
      IF(BC-E2) 56,56,54
   54 RINT3=RINT1
      RINT4=RINT2
      EPS=EPS/2.**5
      IF(XA+SYS059)55,55,59
   55 IF(EPS-CONE  ) 56,56,57
   56 E3=BC
      GO TO 59
   57 A=L
      GO TO 39
   58 Z=.TRUE.
      GO TO 43
   59 IF((B.LT.ALFA.AND.X.EQ.1).OR.(B.GT.BETA.AND.X.EQ.(-1))
     1) GO TO 48
      E=E2
      A=L
      B=J
      C=C+RINT1
      G=G+RINT2
      D=C
      I=G
      IF(Y) GO TO 62
      IF(X+1) 60,60,61
   60 T=E3
      M=B
      B=K
      X=1
      GO TO 38
   61 E3=E3+T
      A=M
      E=2.*E
   62 E1=E3
      RINT1=D
      RINT2=I
      IF(.NOT.(NIS)) GO TO 63
      RINT1=-RINT1
      RINT2=-RINT2
   63 RETURN
      END
